stages:
  - lint
  - test

variables:
  CARGO_HOME: $CI_PROJECT_DIR/cargo
  APT_CACHE_DIR: $CI_PROJECT_DIR/apt

before_script:
  - apt-get --allow-unauthenticated update -yq
  - apt-get install -o dir::cache::archives="$APT_CACHE_DIR" -y dbus

check:
  image: "rustdocker/rustfmt_clippy:stable"
  stage: "lint"
  script:
    - rustc --version
    - cargo --version
    - cargo fmt --all -- --check
    - cargo clippy -- -D warnings

test:
  image: "rustdocker/rustfmt_clippy:stable"
  stage: test
  script:
    - rustc --version
    - cargo --version
    - mkdir -p /run/user/$UID
    - sed s/UID/$UID/ gitlab/dbus-session.conf > /tmp/dbus-session.conf
    - dbus-run-session --config-file /tmp/dbus-session.conf -- cargo test --verbose -- --skip fdpass_systemd
    - dbus-run-session --config-file /tmp/dbus-session.conf -- cargo test --verbose --all-features -- --skip fdpass_systemd

cache:
  paths:
    - apt/
    - cargo/
    - target/
